import machine, onewire, ds18x20, utime
from esp8266_i2c_lcd import I2cLcd
from machine import I2C

#display i2c
DEFAULT_I2C_ADDR = 0x27
sda=machine.Pin(0)
scl=machine.Pin(1)
i2c=machine.I2C(0,sda=sda, scl=scl, freq=400000)
lcd = I2cLcd(i2c, DEFAULT_I2C_ADDR, 2, 16)

#rtc i2c
address = 0x68
register = 0x00
bus = I2C(1)

#Setting the time on the ds3231 - update NowTime string. uncomment ds3231SetTime and run once. re-comment ds3231SetTime
#sec min hour week day mout year
NowTime = b'\x00\x59\x14\x00\x20\x03\x21'
def ds3231SetTime():
    bus.writeto_mem(int(address),int(register),NowTime)

#ds3231SetTime()

ds_pin = machine.Pin(16)
ds_sensor = ds18x20.DS18X20(onewire.OneWire(ds_pin))
relay = machine.Pin(22, machine.Pin.OUT)
led_onboard = machine.Pin(25, machine.Pin.OUT)
relay.value(0)
low = 1
high = 1
zero = 1
roms = ds_sensor.scan()
#print('Found a ds18x20 device')
lcd.putstr("ThermoSwitch!\n     bygonebytes")

for i in range(10):
    ds_sensor.convert_temp()
    utime.sleep_ms(300)
    for rom in roms:
        temp = (round(ds_sensor.read_temp(rom),1))

lcd.clear()
lcd.move_to(8,0)
lcd.putstr('Fan:OFF')

def ds3231ReadTime():
    return bus.readfrom_mem(int(address),int(register),7);

def log_on():
    f=open('Thermo_log.txt', 'a')
    t1=ds3231ReadTime()
    f.write(("20%x, %02x, %02x, %02x, %02x, %02x" %(t1[6],t1[5],t1[4],t1[2],t1[1],t1[0])) + ",  " + "ON" + "\n")    
    f.close()
    
def log_off():
    f=open('Thermo_log.txt', 'a')
    t1=ds3231ReadTime()
    f.write(("20%x, %02x, %02x, %02x, %02x, %02x" %(t1[6],t1[5],t1[4],t1[2],t1[1],t1[0])) + ",,  " + "OFF" + "\n")    
    f.close()

def log_low():
    f=open('Thermo_log.txt', 'a')
    t1=ds3231ReadTime()
    f.write(("20%x, %02x, %02x, %02x, %02x, %02x" %(t1[6],t1[5],t1[4],t1[2],t1[1],t1[0])) + ",,,  " + "Temperature below 8 Degrees" + "\n")    
    f.close()

def log_high():
    f=open('Thermo_log.txt', 'a')
    t1=ds3231ReadTime()
    f.write(("20%x, %02x, %02x, %02x, %02x, %02x" %(t1[6],t1[5],t1[4],t1[2],t1[1],t1[0])) + ",,,  " + "Temperature above 34 Degrees" + "\n")    
    f.close()
    
def log_zero():
    f=open('Thermo_log.txt', 'a')
    t1=ds3231ReadTime()
    f.write(("20%x, %02x, %02x, %02x, %02x, %02x" %(t1[6],t1[5],t1[4],t1[2],t1[1],t1[0])) + ",,,  " + "Zero Degrees and below" + "\n")    
    f.close()

while True:
  ds_sensor.convert_temp()
  utime.sleep_ms(300)
  for rom in roms:
      temp = (round(ds_sensor.read_temp(rom),1))
#    print('Temp: '+(str(temp))+ ' C')
  lcd.move_to(0, 0)
  lcd.putstr(((str(temp))+chr(223)+'C '))
  t = ds3231ReadTime()
  lcd.move_to(0, 1)
  lcd.putstr("%02x:%02x   %02x/%02x/%02x" %(t[2],t[1],t[4],t[5],t[6]))
  led_onboard.toggle()
  utime.sleep_ms(630)
  led_onboard.toggle()
      
  if temp<=0:
      if zero==1:
          zero=0
          log_zero()
      else:
          if temp>1:
              zero=1

  if temp<8:
      if low==1:
          low=0
          log_low()
  else:
      if temp>8.5:
          low=1
            
  if temp>=22:
      if relay.value()==0:
          relay.value(1)
          log_on()
          lcd.move_to(8,0)
          lcd.putstr('Fan:ON ')
          
  else:
      if relay.value()==1:
          if temp>=21.8:
              None
          else:
              relay.value(0)
              log_off()
              lcd.move_to(8,0)
              lcd.putstr('Fan:OFF')
            
  if temp>34:
      if high==1:
          high=0
          log_high()
      else:
          if temp<33.5:
              high=1 
